/* ix/MBox (befehl.c) by Volker Schuermann, 04.12.1993

   This C source code contains the following functions:

   #BE bef()              handles user commands 

   Contact <volkers@unnet.wupper.de> for help! */





#include <stdio.h>

#include "mbox.h"



/* #BE - Handles users commands depending on the following parameters:

         [befehl] may be any command which has to be recognized, or     
                  '?' to order a list of reachable commands.

	 [arg] contains a '*' to order a list of all commands, without
               dependence on user levels.

         
   The functions returns '-1' to tell that the user level isn't high
   enought to execute the command. A '-9' means, the command is not
   known. 

   Any other positive return value is the number of a regular BBS command.
   Have a look at "loop.c", function "loop()" to understand this! */


int bef(befehl, arg)
UNSIGNED char befehl[];
UNSIGNED char arg[];
{
  UNSIGNED char s[STRING];
  UNSIGNED char o[STRING];
  UNSIGNED char tmp[STRING];
 
  int b = 0, i = 0, l;
  int p;
  int toggle = 1;

  FILE *fp;

  l = USER.level;

  if (befehl[0] == '?') {

	sprintf(tmp, "%s/surf.%d", TMP, getpid());

	if (arg[0] == '*'){
		l = 9999;
		unlink(tmp);
	}
	
	fp = fopen( tmp, "r" );
	if(fp != NULL){
		fclose(fp);
		show( tmp, 9999, USER.more );	
		return;
	}

	fp = fopen( tmp, "w" );
	if(fp == NULL){
		nerror("befehl.c", 56, "bef", "Can't write to", tmp);
	}
	
	p = 0;
	strcpy(o, "08/15");

	while (BEF[b].id != -1) {
		if ((BEF[b].prototyp == 1) && (BEF[b].in <= l)) {
		
			strcpy(s, (UNSIGNED char *) strcopy(o, 0, p));

			if(strcomp(s, BEF[b].befehl) == 0){
				do{
					p++;
					strcpy(s, (UNSIGNED char *) strcopy(o, 0, p));
				}while((strcomp(s, BEF[b].befehl) == 0) && 
					(p <= strlen(BEF[b].befehl) - 1) &&
					(p <= strlen(o) - 1));
			}
			else{
				if(o[0] == BEF[b].befehl[0]){
					p = 0;
					while(o[p] == BEF[b].befehl[p]) p++;
				}
				else{
					p = 0;
				}
			} 

			strcpy(o, (UNSIGNED char *) BEF[b].befehl);

			if(USER.terminal != 4){
				if(USER.terminal != ISO6429){
					strcpy(s, (UNSIGNED char *) termansi( "md" ));
					fputs(s, fp);
					fprintf(fp, "%s", strcopy(BEF[b].befehl, 0, p));
					strcpy(s, (UNSIGNED char *) termansi( "me" ));
					fputs(s, fp);
				}
				else{
					if(toggle == 1)
						strcpy(s, (UNSIGNED char *) termansi( "XA" ));
					else
						strcpy(s, (UNSIGNED char *) termansi( "XB" ));
					fputs(s, fp);

					fprintf(fp, "%s", strcopy(BEF[b].befehl, 0, p));
					if(toggle == 1)
						strcpy(s, (UNSIGNED char *) termansi( "XC" ));
					else
						strcpy(s, (UNSIGNED char *) termansi( "XD" ));
					fputs(s, fp);
				}
			}
			else{
				fprintf(fp, "%s", upcased( (UNSIGNED char *) strcopy(BEF[b].befehl, 0, p) ));	
			}

			fprintf(fp, "%-*.*s", (14-p), (14-p), (UNSIGNED char *) strcopy(BEF[b].befehl, (p+1), 80));

			i++;
			if (i == 5) {
				fputs("\n", fp);
				i = 0;
				if(toggle == 1)
					toggle = 0;
				else
					toggle = 1;
			}
			else fputs(" ", fp);
		}
		b++;
	}

	if(i != 0){
		strcpy(s, "                                                                                ");
		s[(79 - (16 * i))] = '\0';
		fprintf(fp, "%s\n", s);
	}
	else fputs("\n", fp);

	fclose(fp);
	show( tmp, 9999, USER.more );

	if (arg[0] == '*'){
		unlink(tmp);
	}

	return 0;
  }
  else {
	while (BEF[b].id != -1) {
		if (strcomp(befehl, BEF[b].befehl) == 0) {
			if (BEF[b].in <= USER.level){
				if(BEF[b].id == 1000){
					printf("\n\n");
					if(arg[0] == '\0')
						sprintf(s, "exec %s %s %d %d", RSH, BEF[b].pfad, OLDUID, OLDGID);
					else
						sprintf(s, "exec %s %s \"%s\" %d %d", RSH, BEF[b].pfad, arg, OLDUID, OLDGID);			
					system(s);
				}
				return BEF[b].id;
			}
			else{
				return -1;
			}
		}
		b++;
	}
	return -9;
  }
}
