/* ix/MBox (portinfo.c) by Volker Schuermann, 04.12.1993

   This C source code contains the following functions:

   #PO port()            BBS internal "who" (better "whodo") function
   #SL show_level()      survey of the user levels
   #UL userliste()       various lists of BBS users   
   #FI finger()          get information on a certain user
   #NU new_user_dir()    updating the users directories (be very careful!)
   #RA rebuild_aliases() add a new entry for every user in smails aliases DB
 
   Contact <volkers@unnet.wupper.de> for help! */





 
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <utmp.h>
#include <time.h>

#include <string.h>

#include "mbox.h"





/* #PO - Show who is doing what ... 
  
   [arg] is a dummy ... no comments, please! */

void port(arg)
UNSIGNED char arg[];
{
  FILE *fp;
  FILE *ff;
  FILE *pp;
  int fd;
  UNSIGNED char s[STRING];
  UNSIGNED char t[STRING];
  UNSIGNED char ks[STRING];
  UNSIGNED char ls[STRING];
  UNSIGNED char tmp[STRING];
  UNSIGNED char ex[LONGSTRING];
  UNSIGNED char terms[MAX_TERMINALS][STRING];
  int termc = 0;
  int a, b, k, l;
  struct utmp US;
  struct tm *tmt;
  long ltime;
  

  if(USER.schluessel[3] != 128){
	headblock( POR01_MSG, POR02_MSG );
  }
  else{
	show_raw( ANSI_PORTINFO, 10 );
	strcpy(ex, (UNSIGNED char *) POR02_MSG );
	strcat(ex, (UNSIGNED char *) "                                                                             ");         
	ex[79] = '\0';
	ansi2( "mr", 0, 0 );
	printf("%s\n", ex );
	ansi2( "me", 0, 0 );
  }

  printf("%s ", POR03_MSG);

  maybe_locked(WHO, "r");
  fp = fopen(WHO, "r");
  if (fp == NULL) {
	nerror("portinfo.c", 56, "port", "Can't read", WHO);
  }
  while (fgets(s, STRING, fp) != NULL) {
	printf(".");
	if(s[0] > 32){
		strcpy(t, (UNSIGNED char *) strcopy(s, 9, 37));
		sprintf(terms[termc], "%s  ", t);
		strcpy(t, (UNSIGNED char *) strcopy(s, 37, STRING));
		strcat(terms[termc], t);
		strcat(terms[termc], "                 ");
		terms[termc][56] = '\0';
		sprintf(t, "%s", (UNSIGNED char *) strcopy(s, 37, 49));

		sprintf(s, "%s/etc/%s.", HOME, (UNSIGNED char *) stripped(t));
		ff = fopen(s, "r");
		if (ff == NULL) {
			continue;
		}
		fgets(s, STRING, ff);
		s[23] = '\0';
		fclose(ff);
		strcat(terms[termc], s);
		strcat(terms[termc], "\n");
		termc++;
	}
  }
  fclose(fp);

  sprintf(tmp, "%s/%dps", TMP, getpid());
  sprintf(s, "ps -a > %s", tmp);
  system( s );

#ifdef _SYS7
  maybe_locked(UTMP, "r");
  fd = open(UTMP, O_RDONLY);
#else
  maybe_locked(UTMP_FILE, "r");
  fd = open(UTMP_FILE, O_RDONLY);
#endif

  if (fd == -1) {

#ifdef _SYS7
	nerror("portinfo.c", 83, "port", "Can't read", UTMP);
#else
	nerror("portinfo.c", 83, "port", "Can't read", UTMP_FILE);
#endif

  }
  while (read(fd, (UNSIGNED char *) &US, sizeof(US)) == sizeof(US)) {
	/*
	printf(".");
	*/
	t[0] = '\0';
	strcat(t, "[$] -\n");

 	if (US.ut_type == USER_PROCESS) {
		terms[termc][0] = '\0';
		sprintf(ex, "%.8s [SH-Account]                                                  ",
			US.ut_user);
		ex[33] = '\0';
		strcat(terms[termc], ex);

		sprintf(ex, "%8.8s   ",
			US.ut_line);
		strcat(terms[termc], ex);

		ltime = US.ut_time;
		tmt = localtime(&ltime);
		sprintf(ex, "%02.2d:%02.2d   ",
			tmt->tm_hour, tmt->tm_min);
		strcat(terms[termc], ex);

		l = atoi(strcopy(US.ut_line, 3, 6));

		pp = fopen(tmp, "r");
		if (pp == NULL) {
			nerror("portinfo.c", 113, "port", "Can't read", tmp);
		}
		while (fgets(s, STRING, pp) != NULL) {
			k = atoi((UNSIGNED char *) strcopy(s, 8, 10));
			if ((k == l) && (s[17] != '-')) {
				t[0] = '\0';
				strcat(t, "[$] ");
				/*
				strcat(t, (UNSIGNED char *) strcopy(s, 17, 40));
				*/
				strcat(t, (UNSIGNED char *) strcopy(s, 21, 40));
				s[0] = '\0';
				strcat(s, t);
				t[0] = '\0';
				strcat(t, (UNSIGNED char *) stripped(s));
				t[27] = '\0';
				strcat(t, "\n");
			}
		}
		fclose(pp);

		strcat(terms[termc], t);
		termc++;
	}
  }
  close(fd);

  unlink(tmp);

  printf("%c", CR);

  for (a = 0; a < termc; a++) {
	for (b = 0; b < termc; b++) {
		sprintf(ks, "%s", (UNSIGNED char *) strcopy(terms[a], 34, 40));
		sprintf(ls, "%s", (UNSIGNED char *) strcopy(terms[b], 34, 40));
		if((strcomp(ks, ls) == 0) && (a != b)){
			if (terms[a][53] == '$') terms[a][0] = '*';
			if (terms[b][53] == '$') terms[b][0] = '*';
		}
		sprintf(s, "%d", ks); k = atoi(s);
		sprintf(s, "%d", ls); l = atoi(s);
		if (k < l) {
			s[0] = '\0';
			strcat(s, terms[a]);
			terms[a][0] = '\0';
			strcat(terms[a], terms[b]);
			terms[b][0] = '\0';
			strcat(terms[b], s);
		}
	}
  }


  for (a = 0; a < termc; a++) {
	if (terms[a][0] != '*'){
		if(terms[a][53] != '$') ansi2( "md", 0, 0 );
		printf("%s", terms[a]);
		if(terms[a][53] != '$') ansi2( "me", 0, 0 );
	}
  }

  printf("\n");
}







/* #SL - Show the user levels and permissions. */

void show_level()
{
  headblock( POR04_MSG, POR05_MSG );

  printf("%s (%d)\n", POR06_MSG, GUEST_LEV);
  printf("%s (%d)\n", POR07_MSG, WRITE_IN_LEV);
  printf("%s (%d)\n", POR08_MSG, MAILOUT_LEV);
  printf("%s (%d)\n", POR09_MSG, WRITE_EX_LEV);
  printf("%s (%d)\n", POR10_MSG, WRITE_INTERNAT);
  printf("%s (%d)\n", POR11_MSG, PD_D_LEV);
  printf("%s (%d)\n", POR12_MSG, PD_U_LEV);
  printf("%s (%d)\n", POR13_MSG, EXE_LEV);
  printf("%s (%d)\n", POR14_MSG, ADMIN_LEV);

  printf("\n%s (%d), %s !\n\n", POR15_MSG, USER.level, USER.name);
}





/* #UL - Show one of a couple of userlists.

   [arg]    ->  ''    = Username and ID, only
                '*'   = Name, last call etc.
                '#'   = Name, Up- / Download
                '$'   = Fees/Charges
                '%'   = Name, level, newsgroups */

void userliste(arg)
UNSIGNED char arg[];
{
  FILE *fp;
  int fd;
  struct userdaten LOOSER;
  UNSIGNED char s[STRING];
  UNSIGNED char u[(STRING*2)];
  UNSIGNED char tmp[STRING];
  UNSIGNED char t[STRING];
  int i = 0, l, z;
  int mode = 0;
  int totalusr = 0;
  int totalact = 0;
  int totalgas = 0;

  UNSIGNED char c;

  if (arg[0] == '*') mode = 1;
  if ((arg[0] == '#') && (USER.level >= ADMIN_LEV)) mode = 2;
  if ((arg[0] == '$') && (USER.level >= ADMIN_LEV)) mode = 3;
  if (arg[0] == '%') mode = 4;
  if ((arg[0] > 47) && (mode == 0)){
	finger(arg);
	return;
  }
 
  show(UDBASE, 99, 99); /* RESET */

  if(mode == 0){
	if(USER.schluessel[3] != 128)
		headline( POR15aMSG );
	else
		show_raw( ANSI_USERS, 10 );
  }
  else{
	if(mode == 1)
		headblock( POR15aMSG, POR16_MSG );

	if(mode == 2)
		headblock( POR15aMSG, POR18_MSG );

	if(mode == 3)
		headblock( POR15aMSG, POR18aMSG );

	if(mode == 4)
		headblock( POR15aMSG, POR18bMSG );

	printf("%s", POR17_MSG);
  }
  
  sprintf(tmp, "%s/%d", TMP, getpid());
  fp = fopen(tmp, "w");
  if (fp == NULL) {
	nerror("portinfo.c", 231, "userliste", "Can't write to", tmp);
  }
  maybe_locked(UDBASE, "r");
  fd = open(UDBASE, O_RDONLY);
  if (fd == -1) {
	nerror("admin.c", 254, "userliste", "Can't read", UDBASE);
  }
  while (read(fd, (UNSIGNED char *) &LOOSER, sizeof(LOOSER)) == sizeof(LOOSER)) {
	if (mode == 0) {
		sprintf(u, "%s", LOOSER.name);
		sprintf(s, " (%d) ", LOOSER.id);		
		u[26 - strlen(s)] = '\0';
		strcat(u, s); strcat(u, "                                ");	
 		u[26] = '\0';
		fprintf(fp, "%s", u);
		i++;
		if (i == 3) {
			i = 0;
			fprintf(fp, "\n");
		}
	}
	if (mode == 1) {
		sprintf(s, "%s", LOOSER.name);
		s[24] = '\0';
		sprintf(u, "%s [%d]", s, LOOSER.id);

		sprintf(s, "%s", "   ");
		if ((LOOSER.elapsed / 60) > 2) {
			if (LOOSER.wohnort[0] < 48) {
				if (strcomp(GUEST, LOOSER.name) != 0)
					sprintf(s, "%s", "<?>");
			}
		}
		else {
			sprintf(s, "%s", "{-}");
		}
		if (LOOSER.seq == 1) {
			sprintf(s, "%s", "<!>");
		}
		fprintf(fp, "%-30.30s  %10s %s%6d %8ld\"  %5d%10.10s\n",
			u, LOOSER.lastlog, s, LOOSER.seq, (LOOSER.elapsed / 60), LOOSER.level, LOOSER.sh_name);

	}
	if (mode == 2) {
		fprintf(fp, "%-30.30s  %8d kB  %10d kB %8d\"\n",
			LOOSER.name, LOOSER.upratio, LOOSER.downratio, (LOOSER.elapsed / 60));
	}
        if (mode == 3) {
		if((atoi(LOOSER.account) > 0) && (LOOSER.level >= WRITE_EX_LEV)){
			if(LOOSER.account[0] == '\0') strcpy(LOOSER.account, "00.00.0000");
			strcpy(s, LOOSER.account);
			s[10] = '\0';
			c = ' ';
			strcpy(t, (UNSIGNED char *) strcopy(LOOSER.account, 11, 16));
			z = atoi(t);			
			if(strcomp("01.01.2001", s) != 0L)
				fprintf(fp, "%-30.30s  %5d   %c %s $\n",  
					LOOSER.name, LOOSER.id, c, s);
			else
				fprintf(fp, "%-30.30s  %5d   %c %s\n",  
					LOOSER.name, LOOSER.id, c, s);

		}
        }
        if (mode == 4) {
		fprintf(fp, "%-15.15s %5d %4d    %s\n",
			LOOSER.name, LOOSER.id, LOOSER.level, LOOSER.newsgrps);
	}       
	totalusr++;
	sprintf(s, "%s", (UNSIGNED char *) mydate( 0 )); 
	if( ((long) dateconv(s) - (long) dateconv(LOOSER.lastlog)) < 30 ) totalact++;
	if(strcomp(GUEST, LOOSER.name) == 0) totalgas = LOOSER.seq;
  }
  close(fd);

  fclose(fp);

  if (mode != 0) {
	printf("%c", CR);
	sprintf(s, "sort -d -o %s %s", tmp, tmp);
	system(s);
	show(tmp, 9999, USER.more + 100);
	if (mode == 1) {
		printf("\n%s\n%s", POR19_MSG, POR20_MSG);
	}
  }
  else{
	if(USER.schluessel[3] != 128)
		show(tmp, 9999, USER.more);
	else
		show(tmp, 9999, USER.more + 1000);
  }
  if(mode == 0){
	printf("\n\n%s %d %s %d %s", POR21_MSG, totalusr, POR22_MSG, totalact, POR23_MSG); 
	printf("\n%s %d %s", POR24_MSG, totalgas, POR25_MSG);
  }
  printf("\n");
  unlink(tmp);
}






/* #FI - Get and show information on a user [arg]. 

   [arg] could be a username or a user-id. */

void finger(arg)
UNSIGNED char arg[];
{
  int fd;
  struct userdaten DUMMY, LOOSER;
  UNSIGNED char s[STRING];
  UNSIGNED char t[STRING];
  long ll = -1L;
  size_t dummy = sizeof(DUMMY);
  UNSIGNED char c;
  UNSIGNED char ex[LONGSTRING];
  int i, ok, a, b;
  int uid = -1;
  UNSIGNED char name[STRING];
  UNSIGNED char domain[STRING];	  


  FILE *fp;

  
  if ((arg[0] > 47) && (arg[0] < 58)) {
	uid = atoi(arg);
  }
  else{
	a = 0; b = 0;
	i = 0;
	while(arg[i] != '\0'){	
		if(arg[i] == '!') a = i;
		if(arg[i] == '@') b = i;
		i++;
	}
	if((a != 0) && (b == 0)){
		if(a != 0){
			strcpy(name, (UNSIGNED char *) strcopy(arg, (a+1), strlen(arg)));
			strcpy(domain, (UNSIGNED char *) strcopy(arg, 0, (a-1)));
		}
		else{
			strcpy(name, (UNSIGNED char *) strcopy(arg, 0, (b-1)));
			strcpy(domain, (UNSIGNED char *) strcopy(arg, (b+1), strlen(arg)));
		}
		strcpy(t, USER.name);
		i = 0;
		while(t[i] != '\0'){
			if(t[i] == ' ') t[i] = '.';
			i++;
		}
		chdir( "/" );
		sprintf(s, "%s %s!%s!\"finger %s\" \\| mail %s@%s", UUX, SMARTHOST, domain, name, t, UUCPID);
		system( s );
		chdir( HOME );
		printf("\n\n%s \"%s\",\n%s \"%s\" %s.", POR25aMSG, name, POR25bMSG, domain, POR25cMSG);
		ansi2( "md", 0, 0 );
		printf("\n%s\n", POR26_MSG);
		ansi2( "me", 0, 0 );
		return;
	}
	else{
		if(b != 0){
			ansi2( "md", 0, 0 );
			printf(" <- %s\n\n", POR26aMSG);
			ansi2( "me", 0, 0 );
			return;
		}
	}
  }

  maybe_locked(UDBASE, "r"); mblock(UDBASE);
  fd = open(UDBASE, O_RDONLY);
  if (fd == -1) {
	nerror("admin.c", 324, "aendern", "Can't read", UDBASE);
  }
  while (read(fd, (UNSIGNED char *) &DUMMY, dummy) == dummy) {
	if (uid == DUMMY.id) {
		ll = lseek(fd, 0L, SEEK_CUR) - dummy;
	} 
	else{
		if ((strcomp(arg, DUMMY.name) == 0) ||
		    (strcomp(arg, DUMMY.nick) == 0) ||
		    (strcomp(arg, DUMMY.sh_name) == 0)) {
			ll = lseek(fd, 0L, SEEK_CUR) - dummy;
		}
	}
  }
  lseek(fd, ll, SEEK_SET);
  read(fd, (UNSIGNED char *) &LOOSER, sizeof(LOOSER));
  close(fd);
  mbunlock(UDBASE);

  if (ll == -1L) {
	ansi2( "md", 0, 0 );
	printf(" <- %s\n\n", POR27_MSG);
	ansi2( "me", 0, 0 );
	return;
  }

  sprintf(s, " %s: %s ", POR28_MSG, arg);
  headline( s );

  ansi2( "md", 0, 0 );
  printf("\n%s ", POR29_MSG);
  ansi2( "me", 0, 0 );
  printf("%d\n", LOOSER.id);

  ansi2( "md", 0, 0 );
  printf("%s ", POR30_MSG);
  ansi2( "me", 0, 0);
  printf("%s\n", LOOSER.name);

  if(LOOSER.sh_name[0] != '\0'){
	ansi2( "md", 0, 0 );
	printf("%s ", POR31_MSG);
	ansi2( "me", 0, 0 );
	printf("%s\n", LOOSER.sh_name);
  }

  if(LOOSER.nick[0] != '\0'){
	ansi2( "md", 0, 0 );
  	printf("%s ", POR32_MSG);
	ansi2( "me", 0, 0 );
	printf("%s\n", LOOSER.nick);
  }

  ansi2( "md", 0, 0 );
  printf("%s ", POR33_MSG);
  ansi2( "me", 0, 0 );
  strcpy(s, LOOSER.name);
  i = 0;
  while(s[i] != '\0'){
	if(s[i] == ' ') s[i] = '.';
	i++;
  }
  if(LOOSER.level >= WRITE_INTERNAT)
	printf("%s@%s\n", s, UUCPID2);
  else
	printf("%s@%s\n", s, UUCPID1);

  printf("\n"); ok = 0;

  if(USER.level >= WRITE_EX_LEV){
	if(LOOSER.wohnort[0] != '\0'){
		ok++;
		ansi2( "md", 0, 0 );
		printf("%s ", POR34_MSG);
		ansi2( "me", 0, 0 );
		printf("%s\n", LOOSER.wohnort);
	}
  }

  if(USER.level >= ADMIN_LEV){
	if(LOOSER.strasse[0] != '\0'){
		ok++;
		ansi2( "md", 0, 0 );
		printf("%s ", POR35_MSG);
		ansi2( "me", 0, 0 );
		printf("%s\n", LOOSER.strasse);
	}
	if(LOOSER.telefon1[0] != '\0'){
		ok++;
		ansi2( "md", 0, 0 ); 
		printf("%s ", POR36_MSG);
		ansi2( "me", 0, 0 );
		printf("%s", LOOSER.telefon1);

		if(LOOSER.telefon2[0] != '\0'){
			printf(" // %s\n", LOOSER.telefon2);
		}
		else{
			printf("\n");
		}
	}

	if(ok != 0) printf("\n"); 
	ok = 0;

	if(LOOSER.geburtsdatum[0] != '\0'){
		ok++;
		ansi2( "md", 0, 0 );
		printf("%s ", POR37_MSG);
		ansi2( "me", 0, 0 );
		printf("%s\n", LOOSER.geburtsdatum);
	}
  }

  if(ok != 0) printf("\n");

  if(USER.level >= WRITE_EX_LEV){
	ansi2( "md", 0, 0 );
	printf("%s ", POR38_MSG);
	ansi2( "me", 0, 0 );
	printf("%d\n", LOOSER.seq);
  	ansi2( "md", 0, 0 );
	printf("%s ", POR39_MSG);
	ansi2( "me", 0, 0 );
	printf("%s // %s\n", LOOSER.lastlog, (UNSIGNED char *) timereconv(LOOSER.lasttime));
  }

  ansi2( "md", 0, 0 );
  printf("%s ", POR45_MSG);
  ansi2( "me", 0, 0 );
 
  b = 0;
  sprintf(s, "%s/usr/%c/%d/INDEX", HOME, LOOSER.name[0], LOOSER.id);  
	
  fp = fopen(s, "r");
  if (fp == NULL) {
	nerror("intro.c", 291, "intro", "Can't read", s);
  }
  while (fgets(ex, LONGSTRING, fp) != NULL){
	if(ex[0] < 65) b++;
  }
  fclose(fp);
  printf("%d\n", b-1);

  if(USER.level >= ADMIN_LEV){
	ansi2( "md", 0, 0 );
	printf("%s ", POR40_MSG);
	ansi2( "me", 0, 0 );
	b = LOOSER.elapsed/(3600*24);
	printf("%d %s, ", b, POR41_MSG);
	a = (LOOSER.elapsed - (b*(3600*24)))/3600; 
	printf("%d %s, ", a, POR41aMSG);
        b = (LOOSER.elapsed - (b*(3600*24)) - (a*3600))/360;
   	printf("%d %s\n", b, POR41bMSG);
        ansi2( "md", 0, 0 );
        printf("%s ", POR41cMSG);
        ansi2( "me", 0, 0 );
        printf("%s\n", LOOSER.account);
	ansi2( "md", 0, 0 );
	printf("%s ", POR42_MSG);
	ansi2( "me", 0, 0 );
	printf("%ld %s\n", LOOSER.upratio, POR43_MSG);
	ansi2( "md", 0, 0 );
	printf("%s ", POR44_MSG);
	ansi2( "me", 0, 0 );
	printf("%ld %s\n", LOOSER.downratio, POR43_MSG);
  }

  printf("\n");

  sprintf(s, "%s/usr/%c/%d/.plan", HOME, LOOSER.name[0], LOOSER.id);  
  fp = fopen( s, "r" );
  if(fp != NULL){
	fclose(fp);
 
	ansi2("mr", 0, 0);
	printf("%c%s [%c, %c] > ", CR, POR46_MSG, GBL06_MSG, GBL07_MSG);
	ansi2("me", 0, 0);

	c = yesno();

	if (c == GBL06_MSG) {
		sprintf(s, " %s: %s ", POR28_MSG, arg);
		headline( s );

		sprintf(s, "%s/usr/%c/%d/.plan", HOME, LOOSER.name[0], LOOSER.id);
		show( s, 9999, USER.more );	
	}
  }

  printf("\n");
}





/* #RA - Add an entry for every user in smails aliases DB */

void new_user_dir()
{
  FILE *fp;
  int fd;
  struct userdaten LOOSER;
  UNSIGNED char s[STRING];

  int i;

  headline( " Updating User Directories " );

  printf("\n");

  maybe_locked(UDBASE, "r");
  fd = open(UDBASE, O_RDONLY);
  if (fd == -1) {
	nerror("admin.c", 254, "userliste", "Can't read", UDBASE);
  }
  while (read(fd, (UNSIGNED char *) &LOOSER, sizeof(LOOSER)) == sizeof(LOOSER)) {

	for(i = 'A'; i <= 'Z'; i++){
		sprintf(s, "%s/usr/%c", HOME, i);
#ifndef _LINUX
		mkdir( s );
		chmod( s, 0777 );
#else
		mkdir( s, 0777 );
#endif
	}

	sprintf(s, "%s/usr/%d/.dummy", HOME, LOOSER.id); /* New User-Directory !!! */

	printf("%s (%d)", LOOSER.name, LOOSER.id);

	fp = fopen( s, "w" );
	if(fp != NULL){
		fclose(fp);
		unlink(s);
		sprintf(s, "%s/usr/%c", HOME, LOOSER.name[0]);
#ifndef _LINUX
		mkdir( s );
		chmod( s, 0777 );
#else
		mkdir( s, 0777 );
#endif
		sprintf(s, "%s/usr/%c/%d", HOME, LOOSER.name[0], LOOSER.id);
#ifndef _LINUX
		mkdir( s );
		chmod(s , 0777 );
#else
		mkdir( s, 0777 );
#endif
		sprintf(s, "cp %s/usr/%d/.* %s/usr/%c/%d > /dev/null 2>&1", HOME, LOOSER.id, HOME, LOOSER.name[0], LOOSER.id);
		system( s );
		sprintf(s, "cp %s/usr/%d/* %s/usr/%c/%d > /dev/null 2>&1", HOME, LOOSER.id, HOME, LOOSER.name[0], LOOSER.id);
		system( s );
		sprintf(s, "rm -r %s/usr/%d > /dev/null 2>&1", HOME, LOOSER.id);
		system( s );
	}

	printf("%c                                                                  %c", CR, CR);
  }
  close(fd);

  printf("\n");
}


void rebuild_aliases()
{
  FILE *fp;
  int fd;
  struct userdaten LOOSER;
  UNSIGNED char s[STRING];
  UNSIGNED char t[STRING];

  int i;

  headline( " Rebuilding Aliases Database" );

  printf("\n");

  maybe_locked(UDBASE, "r");
  fd = open(UDBASE, O_RDONLY);
  if (fd == -1) {
	nerror("admin.c", 254, "userliste", "Can't read", UDBASE);
  }
  while (read(fd, (UNSIGNED char *) &LOOSER, sizeof(LOOSER)) == sizeof(LOOSER)) {

	i = 0;
	strcpy(t, (UNSIGNED char *) LOOSER.name);
	while(t[i] != '\0'){
		if(t[i] == ' ') t[i] = '.';
		i++;
	}
	
	sprintf(s, "/bin/sh ./etc/alias.sh \"%s\"", t);
	system( s );
	printf("%s\n", t);
  }
  close(fd);

  printf("\n");
}

