/* ix/MBox (subscribe.c) by Volker Schuermann, 09.04.1994

   This C source code contains the following functions:

   #IS is_subscribed()    check if user has subscribed to a newsgroup
   #SB subscribe()        (un-) subscribe to newsgroups
   #GL gloom()		  compile a "weather report"

   Contact <volkers@unnet.wupper.de> for help! */










#include <stdio.h>

#include "mbox.h"


/* #IS - Check if users subscribed to a newsgroup [s].

   This function returns 1 if the user has subscribed to the group, or
   0 otherwise. */

int is_subscribed( s )
UNSIGNED char s[];
{
  FILE *subfp;

  UNSIGNED char t[STRING];
  int is = 0;

  sprintf(t, "%s/usr/%c/%d/.subscribe", HOME, USER.name[0], USER.id);
  subfp = fopen( t, "r" );
  if(subfp == NULL){
	return (int) 1;		/* 1 is correct !!! */
  }
  while((fgets(t, STRING, subfp) != NULL) && (is == 0)){
	if(strcomp(s, t) == 0) is = 1;
  }
  fclose(subfp);

  return (int) is;
}


/* #SB - (Un-) subscribe to newsgroups. */

void subscribe()
{
  FILE *fp;
  FILE *ff;

  UNSIGNED char s[STRING];
  UNSIGNED char t[STRING];
  UNSIGNED char tmp[STRING];

  UNSIGNED char g[45][STRING];

  int a, b, c, i = 0, p = 1;
  int OK = 1;
  int SKIP = 0;

  int help_shown = 0;

  int m[45];

  char mark;


  if(USER.tlines > 45){
	nerror("subscribe.c", 57, "subscribe", "Terminal made up with", "45 line ???");
  }


  sprintf(s, " %s %d] ", SUB01_MSG, p);
  headline( s );


  sprintf(tmp, "%s/subscribe.%d", TMP, getpid() );
  ff = fopen(tmp, "w");
  if(ff == NULL){
	nerror("subscribe.c", 68, "subscribe", "Can't write to", tmp);
  }

  fp = fopen( NGROUPS, "r" );
  if(fp == NULL){
	nerror("subscribe.c", 73, "subscribe", "Can't read", NGROUPS);
  }

  while(OK == 1){
	if(fscanf(fp, "%s %d %d %s", s, &a, &b, t) <= 0){
	        OK--;
	}
	else{
	        if(chk_newsgrp( s ) != -1){

	                strcpy(g[(i+1)], (UNSIGNED char *) s);
	                if(is_subscribed( s )){
	                        if(!SKIP){
					if((i + 'A') <= 'Z')
						printf("-> %c  %-40s  %d\n", (i + 'A'), s, (a -b));
					else
						printf("-> %c  %-40s  %d\n", (i + 'A' + 6), s, (a -b));
				}
	                        m[(i+1)] = 1;
	                }
	                else{
				if(!SKIP){
					if((i + 'A') <= 'Z')
					  	printf("   %c  %-40s  %d\n", (i + 'A'), s, (a -b));
					else
						
					  	printf("   %c  %-40s  %d\n", (i + 'A' + 6), s, (a -b));
				}
	                        m[(i+1)] = 0;
	                }
	                i++;
	        }
	}

	if((i == (USER.tlines -1)) || (OK != 1)){
		if(!SKIP){
		        printf("\n");
		        ansi2( "mr", 0, 0 );
		        printf("[A-%c, !, *] (?) > ", (i + 'A' -1));
		        ansi2( "me", 0, 0 );
		        c = 0;
		        while(c != ' '){
		                c = getint();
	        	        if(help_shown == 1){
					clearline();
					ansi2( "mr", 0, 0 );
			                    printf("[A-%c, !, *] (?) > ", (i + 'A' -1));
	                	        ansi2( "me", 0, 0 );
		                        help_shown = 0;
		                }
		                if(c == '?'){
		                        clearline();
		                        ansi2( "mr", 0, 0 );
		                        printf("%s > ", SUB02_MSG);
		                        ansi2( "me", 0, 0 );
		                        help_shown = 1;
		                }
		                if(c == '*'){
		                        sprintf(s, "%s/usr/%c/%d/.subscribe", HOME, USER.name[0], USER.id);
		                        unlink(s);
		                        ansi2( "cm", 20, (i + 3) );
		                        printf(" %s ", SUB06_MSG);
					sleep(1);
		                        OK = 99;
		                        c = ' ';
		                }
				if(c == '!'){	
					printf(" %s ", SUB06aMSG);
					sleep(1);
					SKIP = 1;
					c = ' ';
				}
				if(USER.tlines > 40){
					if(c > 'Z') c -= 6;
				}
				else{
					if(c >  96) c -= 96;
				}
		                if(c > 64) c -= 64;
		                if(c <= i){
					ansi2( "cm", 1, (c + 1) );
		                        ansi2( "md", 0, 0 );
		                        if(m[c] == 0){
		                                m[c] = 1;
		                                printf("->");
		                                ansi2( "cm", 20, (i + 3) );
		                                ansi2( "me", 0, 0 );
		                                printf(" %s <%s> %s           ", SUB03_MSG, g[c], SUB04_MSG );
		                        }

		                        else{
		                                m[c] = 0;
		                                printf("  ");
		                                ansi2( "cm", 20, (i + 3) );
		                                ansi2( "me", 0, 0 );
		                                printf(" %s <%s> %s            ", SUB03_MSG, g[c], SUB05_MSG );
		                        }
		                        ansi2( "cm", 19, (i + 3) );
		                }
		        }
		}
	        for(a = 1; a <= i; a++){
	                if(m[a] == 1) fprintf(ff, "%s\n", g[a]);
	        }
		fflush(ff);
		if((OK == 1) && (!SKIP)){
	                p++;
	                sprintf(s, " %s %d] ", SUB01_MSG, p);
	                headline( s );
	        }
		i = 0;		
	}
  }
  clearline();

  fclose(fp);
  fclose(ff);

  if(OK != 99){
	sprintf(s, "%s/usr/%c/%d/.subscribe", HOME, USER.name[0], USER.id);
	mbrename( tmp, s );
  }
  else{
	unlink( tmp );
  }

  init_user( SUB07_MSG, 1 );

  printf("\n");
}



/* #GL - compile a "weather report" */

void gloom()
{
  UNSIGNED char s[STRING];
  UNSIGNED char wet[15][STRING];
  UNSIGNED char tem[10][STRING];
  UNSIGNED char t[STRING];
  UNSIGNED char l[LONGSTRING];
  int c = srand( getpid() );		/* No comments needed! */
  int hit = (rand() % 15) + 1;
  int temp = (rand() % 10) + 1; 
  int i;
 
  FILE *fp;


 
  strcpy(wet[ 1], (UNSIGNED char *) "it was hot and dry");
  strcpy(wet[ 2], (UNSIGNED char *) "it has been sunny and mild");
  strcpy(wet[ 3], (UNSIGNED char *) "the skies have been cloudy");
  strcpy(wet[ 4], (UNSIGNED char *) "the skies were overcast with showers");
  strcpy(wet[ 5], (UNSIGNED char *) "we had hail and thunder");
  strcpy(wet[ 6], (UNSIGNED char *) "we had torrential rain");
  strcpy(wet[ 7], (UNSIGNED char *) "it was stormy and showery");
  strcpy(wet[ 8], (UNSIGNED char *) "it was foggy and misty");
  strcpy(wet[ 9], (UNSIGNED char *) "it was misty and murky");
  strcpy(wet[10], (UNSIGNED char *) "we had gails and gusts");
  strcpy(wet[11], (UNSIGNED char *) "we had showery rain and snow");
  strcpy(wet[12], (UNSIGNED char *) "it was foggy with showers");
  strcpy(wet[13], (UNSIGNED char *) "we had clouds and high winds");
  strcpy(wet[14], (UNSIGNED char *) "it was freezing cold");
  strcpy(wet[15], (UNSIGNED char *) "it has had blizzard conditions");

  strcpy(tem[ 1], (UNSIGNED char *) "-25 C (-13 F)");
  strcpy(tem[ 2], (UNSIGNED char *) "-10 C (14 F)");
  strcpy(tem[ 3], (UNSIGNED char *) "5 C (41 F)");
  strcpy(tem[ 4], (UNSIGNED char *) "10 C (50 F)");
  strcpy(tem[ 5], (UNSIGNED char *) "15 C (60 F)");
  strcpy(tem[ 6], (UNSIGNED char *) "20 C (68 F)");
  strcpy(tem[ 7], (UNSIGNED char *) "25 C (75 F)");
  strcpy(tem[ 8], (UNSIGNED char *) "30 C (86 F)");
  strcpy(tem[ 9], (UNSIGNED char *) "35 C (95 F)");
  strcpy(tem[10], (UNSIGNED char *) "40 C (104 F)");

  do{
	headline( " Weather Report (MET Office) " );

	ansi2( "cm", 1, 6 );

  	for(i = 1; i <= 15; i++){
		printf("%c ... %s\n", (i + 64), wet[i]);
	}

	ansi2( "md", 0, 0 );

	for(i = 1; i <= 10; i++){
		ansi2( "cm", 48, (5 + i) );
		if(i < 3)
			printf("%d ... %s", (i - 1), tem[i]);
		if( i == 3)
			printf("%d ...   %s", (i - 1), tem[i]);
		if( i > 3)
			printf("%d ...  %s", (i - 1), tem[i]);
	}

	ansi2( "me", 0, 0 );

	sprintf(l, "This weather report has been compiled in %s, where %s. %s %s.", 
		    LOCATION, wet[hit],
		   "Daytime temperatures reached", tem[temp]);

	i = 79;
	while(l[i] != ' ') i--;
	l[i] = '\n';


	ansi2( "cm", 1, 3 );
	ansi2( "us", 0, 0 );
	printf("%s", l);
	ansi2( "me", 0, 0 );

	ansi2( "cm", 1, 23 );
	ansi2( "md", 0, 0 );
	printf("[A-O, 0-9] Und? > ");
  	ansi2( "me", 0, 0 );

	c = getch();

	if(c >= 97) c -= 32;


	if((c >= 'A') && (c <= 'O')) hit = (c - 64);

	if((c >= '0') && (c <= '9')) temp = (c - 47);
		
  }while(c != ENTER); 

  ansi2( "cm", 0, 22 ); 

  fp = fopen( WEATHER_REPORT, "w" );
  if(fp == NULL){
	nerror("subscribe.c", 321, "gloom", "Can't open", WEATHER_REPORT);
  }
  fputs("\n------------------------------------------------------------------------------\n", fp); 
  fputs(l, fp);
  fclose(fp);
}
