/* ix/MBox (weiterl.c) by Volker Schuermann, 04.12.1993

   This C source code contains the following functions:

   #WL weiterleiten()    forward mails or articles
   #CC carboncopy()      send copies to other users
   #BO boerse()          stock exchange ("de.etc.finanz")

   Contact <volkers@unnet.wupper.de> for help! */






#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>

#include "mbox.h"




/* #WL - Forward mails.

   [arg]    ->  ''             = show which mail may be forwarded
            ->  'user'         = forward the last mail to 'user'
            ->  'article user' = forward 'article' to 'user' */

void weiterleiten( arg )
UNSIGNED char arg[];
{
  FILE *fp;
  UNSIGNED char s[STRING];
  UNSIGNED char t[STRING];
  UNSIGNED char subject[STRING];
  int i, a, num;
  UNSIGNED char empf[STRING];

  subject[0] = '\0';

  sprintf(s, "%s/usr/%c/%d/.lastsubject", HOME, USER.name[0], USER.id);
  fp = fopen( s, "r" );
  if(fp != NULL){
	fgets(subject, STRING, fp);
	fclose(fp);
  }

  if((subject[0] == '\0') && ((arg[0] > 64) || (arg[0] == '?'))){
	ansi2("md", 0, 0);
	printf(" %s\n", WEI01_MSG);
	ansi2("me", 0, 0);
	return;
  }

  if(arg[0] == '\0'){
	printf("\n\n%s\n\n", WEI02_MSG);
	ansi2("md", 0, 0);
	printf("%s %s\n\n", WEI03_MSG, subject);
	ansi2("me", 0, 0);
	return;
  }

  num = 0;

  if(arg[0] < 65){
	i = 0;
	while((arg[i] > 32) && (arg[i] != '\0')) i++;
	strcpy(s, (UNSIGNED char *) strcopy(arg, 0, (i-1)));
	num = atoi(s);
	strcpy(empf, (UNSIGNED char *) strcopy(arg, (i+1), strlen(arg)));
	strcat(empf, "$");
  }
  else{
	sprintf(empf, "%s$", arg);
  }  

  if(num != 0){
	if(strcomp(BRETT, "PM") != 0){
		sprintf(t, "%s/%d", BRETT, num);
		sprintf(s, "cp %s/%d %s/usr/%c/%d/.lastletter", BRETT, num, HOME, USER.name[0], USER.id);
	}
	else{
		sprintf(t, "%s/usr/%c/%d/%d", HOME, USER.name[0], USER.id, num);
		sprintf(s, "cp %s/usr/%c/%d/%d %s/usr/%c/%d/.lastletter", HOME, USER.name[0], USER.id, num, HOME, USER.name[0], USER.id);
	}
	fp = fopen( t, "r" );
	if(fp == NULL){
		ansi2("md", 0, 0);
		printf(" %s\n", WEI04_MSG);
		ansi2("me", 0, 0);
	return;
	}
	fclose(fp);
	system(s);
	sprintf(s, "%s/usr/%c/%d/.lastletter", HOME, USER.name[0], USER.id);

	sprintf(s, "%s/usr/%c/%d/.lastsubject", HOME, USER.name[0], USER.id);
	fp = fopen( s, "w" );
	if(fp == NULL){
		nerror("weiterl.c", 76, "weiterleiten", "Can't write to", s);
	}
	fprintf(fp, "%d <%s>", num, NG);
	fclose(fp);
  }

  brief(empf);
}




/* #CC - Send copies of mails to various users.

   [cc]   ->  name of users (shown in "Cc:" header line)
   [bcc]  ->  name of users (shown in "Bcc:" header line, not shown to
              users) */

void carboncopy( cc, bcc )
UNSIGNED char cc[], bcc[];
{
  UNSIGNED char ex[LONGSTRING];
  UNSIGNED char ef[LONGSTRING];
  UNSIGNED char s[STRING];

  int a = 0, i = 0;
  int ok = 0;

  printf("\n");

  sprintf(ex, "%s,%s ", (UNSIGNED char *) stripped(cc), bcc);

  if(ex[0] == '\0') return;

  while(ok == 0){
	while((ex[i] != ',') && (ex[i] != '\0')) i++;

	if(ex[i] == '\0') ok++;

	strcpy(ef, (UNSIGNED char *) bigcopy(ex, a, (i-1)));
	strcpy(s, (UNSIGNED char *) stripped(ef));

	if((strlen(s) > 1) && (s[0] != '(')){
		weiterleiten( s );
	}
	a = i + 1;
	i++;
  }
  
}




/* #BO - Handle stock exchange database.

   This needs informations from newsgroup "de.etc.finanz".

   NOTE: This stuff is still under construction!  */

#define MAX_BOERSE	40
#define MAX_KURSE	40

void boerse( arg )
UNSIGNED char arg[];
{
  UNSIGNED char s[STRING];
  UNSIGNED char t[STRING];
  UNSIGNED char u[STRING];

  UNSIGNED char d[MAX_BOERSE][STRING];
  UNSIGNED char l[MAX_KURSE][STRING];
  int dptr;

  FILE *fp;
  FILE *ff;

  int c, i, j, a, b;

  long t1, t2;
  long o1, o2;
  long p1;
  long x1, x2;
  long q;

  DIR *dp;
  struct dirent *actdir;



  if(USER.terminal == 4){
	printf(" <- %s\n", BAU04_MSG );
	return;
  }


  sprintf(s, " Stock Exchange                      [Support: %s] ", STOCK_AUTOR);
  headline( s );

  fp = fopen( STOCK_INDEX, "r" );
  if(fp != NULL){

	ansi2( "cm", 56, 3 );
	printf("DAX ........");
	ansi2( "cm", 56, 4 );
	printf("FTSE .......");
	ansi2( "cm", 56, 5 );
	printf("DOW JONES ..");
	ansi2( "cm", 56, 6 );
	printf("CAC ........");
	ansi2( "cm", 56, 7 );
	printf("MIBTEL .....");
	ansi2( "cm", 56, 8 );
	printf("IBEX .......");

	while(fgets(s, STRING, fp) != 0){
		if(strlen(s) > 10) strcpy(t, (UNSIGNED char *) s);
	}

	fclose(fp);

	ansi2( "md", 0, 0 );

	j = 12;

	for(i = 3; i < 9; i++){
		ansi2( "cm", 69, i );
		printf("%s", (UNSIGNED char *) strcopy(t, j, (j + 8)));
		j += 11;
 	}  	

	ansi2( "cm", 56, 10 );
	ansi2( "mr", 0, 0 );
	printf("      %s      ", (UNSIGNED char *) strcopy(t, 0, 9) );
  }

  ansi2( "cm", 1, 2 );
  ansi2( "me", 0, 0 ); 

  printf("\n  1 - DAX Aktien Kurse\n");
  printf("\n  2 - Dow Jones Aktien Kurse\n");
  ansi2( "us", 0, 0 );
  printf("\n  3 - Diagramm\n\n\n");
  ansi2( "me", 0, 0 );  

  ansi2( "md", 0, 0 );
  printf("[Kurse] Welche? > ");

  c = getint();

  ansi2( "me", 0, 0 );

  if((c < '1') || (c > '3')){
	printf("\n");
	return;
  }

  if(c != '3'){

	sprintf(s, " Stock Exchange                      [Support: %s] ", STOCK_AUTOR);
	headline( s );

	dptr = 1;

	dp = opendir( STOCK_PATH );
	if(dp == NULL){
		nerror("weiterl.c", 216, "boerse", "Directory not found", STOCK_PATH);
	}
  
	while(((actdir = readdir(dp)) != NULL) && (dptr < MAX_BOERSE)){
		strcpy(s, (UNSIGNED char *) actdir->d_name);
		i = strlen(s);
		if(i > 3){
			while(i > -1){
				if(s[i] == '.'){
					a = i + 1;
					i = -1;
				}
				i--;
			}
			strcpy(t, (UNSIGNED char *) strcopy(s, a, strlen(s)));
	
			if(c == '1'){
				if(strcomp("dax", t) == 0){
					strcpy(d[dptr], actdir->d_name);
					dptr++;
				}
			}
			if(c == '2'){
				if(strcomp("dj", t) == 0){
					strcpy(d[dptr], actdir->d_name);
					dptr++;
				}	
			}
		}
	}
	closedir(dp);

  
	for(i = 1; i < dptr; i++){
		for(j = 1; j < dptr; j++){
			t1 = dateconv( d[i] );
			t2 = dateconv( d[j] );
			if(t1 > t2){
				strcpy(s, (UNSIGNED char *) d[i]);
				strcpy(d[i], (UNSIGNED char *) d[j]);
				strcpy(d[j], (UNSIGNED char *) s);
			}
		}
	}
	
	
	j = 0; strcpy(l[0], "                               "); 

	if(dptr > 5) dptr = 5;

	for(i = 1; i < dptr; i++){
	
		sprintf(s, "%s/%s", STOCK_PATH, d[i]);

		b = 1;
	
		fp = fopen( s, "r" );
		if(fp == NULL){
			nerror("weiterl.c", 274, "boerse", "Can't read", s);
		}
	
		strcat(l[0], "    ");
		strcat(l[0], (UNSIGNED char *) strcopy(d[i], 0, 7));
	
		while(fgets(s, STRING, fp) != 0){
			if(j == 0){
				strcpy(l[b], stripped( (UNSIGNED char *) strcopy(s, 7, 80)));
				while(strlen(l[b]) < 31) strcat(l[b], " ");	
				l[b][31] = '\0';
			}
			fgets(t, STRING, fp);
			if(s[0] == t[0]){
				sprintf(s, "   %9.9s", stripped( (UNSIGNED char *) strcopy(t, 7, 80)));
			}
			else{
				sprintf(s, "   %9.9s", "WPKN?");
			}
			strcat(l[b], s);
			if(b < MAX_KURSE) b++;
	   	}
		fclose(fp);
	
		j++;
	}  

	sprintf(t, "%s/city.%d", STOCK_PATH, getpid());

	fp = fopen( t, "w" );
	if(fp == NULL){
		nerror("weiterl.c", 303, "boerse", "Can't write to", t);
	}

	fputs("Content-Type: text/richtext\n", fp);

	a = 0;

	for(i = 1; i < b; i++){
		if(l[i][0] >= 'A'){
			if(a == 0){
				fprintf(fp, "%s\n", l[i]);
				a++;
			}
			else{
				fprintf(fp, "<Underline>%s</Underline>\n", l[i]);
				a = 0;
			}
		}
	}
	fclose(fp);

	sprintf(s, " Stock Exchange                      [Support: %s] ", STOCK_AUTOR);
	headblock( s, l[0] );
	show( t, 9999, USER.more + 100 );

	unlink( t );

  }	
  else{ /* Grafik */

	sprintf(s, " Stock Exchange                      [Support: %s] ", STOCK_AUTOR);
	headline( s );

	dptr = 1;

	dp = opendir( STOCK_PATH );
	if(dp == NULL){
		nerror("weiterl.c", 341, "boerse", "Directory not found", STOCK_PATH);
	}
  
	while((actdir = readdir(dp)) != NULL){
		if(dptr >= MAX_BOERSE){
			for(i = 1; i <= dptr; i++)
				strcpy(d[i], (UNSIGNED char *) d[i+1]);
			dptr--;
		}
		strcpy(s, (UNSIGNED char *) actdir->d_name);
		i = strlen(s);
		if(i > 3){
			while(i > -1){
				if(s[i] == '.'){
					a = i + 1;
					i = -1;
				}
				i--;
			}
			strcpy(t, (UNSIGNED char *) strcopy(s, a, strlen(s)));
	
			if((strcomp("wpkn", t) != 0) && (strcomp("index", s) != 0)){
				strcpy(d[dptr], actdir->d_name);
				dptr++;
			}
		}
	}
	closedir(dp);

  
	for(i = 1; i < dptr; i++){
		for(j = 1; j < dptr; j++){
			t1 = dateconv( d[i] );
			t2 = dateconv( d[j] );
			if(t1 < t2){
				strcpy(s, (UNSIGNED char *) d[i]);
				strcpy(d[i], (UNSIGNED char *) d[j]);
				strcpy(d[j], (UNSIGNED char *) s);
			}
		}
	}

	b = 1; t1 = 9999L; t2 = 0L; o1 = 9999L; o2 = 0L;
	
	for(i = 1; i < dptr; i++){				/* Pass 1 */
		sprintf(s, "%s/%s", STOCK_PATH, d[i]);
	
		fp = fopen( s, "r" );
		if(fp == NULL){
			nerror("weiterl.c", 385, "boerse", "Can't read", s);			
		}
	
		fgets(t, STRING, fp); 
		fgets(s, STRING, fp); 

		if(atol(t) != atol(s)){	/* WPKN ??? */
			fclose(fp);
			continue;
		}

		strcpy(l[b], (UNSIGNED char *) strcopy(s, 7, 80));

		q = atol(l[b]);
	
		if(d[i][strlen(d[i]) -1] == 'x'){
			if(q < t1) t1 = q;
			if(q > t2) t2 = q;
		}
		else{
			if(q < o1) o1 = q;
			if(q > o2) o2 = q;
		}

		if(b < MAX_KURSE) b++;
		fclose(fp);
	}

	t1 = (t1 + t2) / 2;
	o1 = (o1 + o2) / 2;	

	x1 = (t2 - t1) / 10 + 1;
	x2 = (o2 - o1) / 10 + 1;

	a = 15;

	for( i = 3; i < (42 - USER.tlines); i++){
		ansi2( "cm", 14, i );
		printf("------------------------------------------------------------------");
	}


	ansi2( "md", 0, 0 );
	ansi2( "cm", 14, 12 );
	printf("------------------------------------------------------------------");
	ansi2( "cm", 14, (42 - USER.tlines) );
	printf("------------------------------------------------------------------");

	ansi2( "me", 0, 0 );

	for( i = 4; i < 7; i++){
		ansi2( "cm", 68, i );
		printf("             ");
	}

	ansi2( "cm", 69, 4 );
	ansi2( "mr", 0, 0 );
	printf("=");
	ansi2( "me", 0, 0 );
	ansi2( "md", 0, 0 );
	printf(" DAX");
	ansi2( "me", 0, 0 );

 	ansi2( "cm", 69, 6 );
	ansi2( "mr", 0, 0 );
	printf("+");
	ansi2( "me", 0, 0 );
	printf(" Dow Jones");

	ansi2( "cm", 58, (41 - USER.tlines) );
	ansi2( "us", 0, 0 );
	strcpy(t, (UNSIGNED char *) strcopy(d[(dptr - 1)], 0, 7));
  	printf(" %s bis %s", (UNSIGNED char *) strcopy(d[1], 0, 7), t); 
	ansi2( "me", 0, 0 );

	j = 1;
	/*
        if(dptr > 22) j = dptr - 22;
	*/
 	if(dptr > 27) j = dptr - 27;

	for(i = j; i < dptr; i++){				/* Pass 2 */
		sprintf(s, "%s/%s", STOCK_PATH, d[i]);
	
		fp = fopen( s, "r" );
		if(fp == NULL){
			nerror("weiterl.c", 476, "boerse", "Can't read", s);
		}
	
		fgets(t, STRING, fp); 
		fgets(s, STRING, fp); 

		if(atol(t) != atol(s)){	/* WPKN ??? */
			fclose(fp);
			continue;
		}

		strcpy(t, (UNSIGNED char *) strcopy(s, 7, 80));
			
		q = atol(t);

		ansi2( "mr", 0, 0 );

		if(d[i][strlen(d[i]) -1] == 'x'){

			p1 = t1 - q;
			p1 /= x1;
			if(p1 == 0) p1 = 1;

			
			if(p1 > 0){
				for(j = 0; j < p1; j++){
					b = 12 + j;
					ansi2( "cm", a, b);
					printf("=");
				}
			}
			else{
				p1 *= -1;

				for(j = 0; j < p1; j++){
					b = 12 - j;
					ansi2( "cm", a, b);
					printf("=");
				}

			}
			
			ansi2( "cm", 1, b);
			ansi2( "me", 0, 0 );
			ansi2( "md", 0, 0 );
			printf("%s", t);
		}
		else{
			p1 = o1 - q;
			p1 /= x2;
			if(p1 == 0) p1 = 1;


			if(p1 > 0){
				for(j = 0; j < p1; j++){
					b = 12 + j;
					ansi2( "cm", a, b);
					printf("+");
				}
			}
			else{
				p1 *= -1;

				for(j = 0; j < p1; j++){
					b = 12 - j;
					ansi2( "cm", a, b);
					printf("+");
				}

			}
			ansi2( "cm", 1, b);
			ansi2( "me", 0, 0 );
			printf("%s", t);
		}

		for(j = 0; j < 2; j++){
			ansi2( "cm", a, (43 - USER.tlines) + j );
			printf("%c", d[i][j]);
		}

		ansi2( "me", 0, 0 );

		a += 2;

		fclose(fp);
	}	
	ansi2( "cm", 1, (USER.tlines + 1) );
  }
}
